#include <windows.h>
#include <stdio.h>

#ifdef _UNICODE
#warning unicode
#endif

int main(void)
{
	HANDLE hSerial;
	DCB dcb;
	DWORD nWrote = 0;
	char msg[] = "R";
	char length = strlen(msg);

	hSerial = CreateFile("COM3", GENERIC_READ | GENERIC_WRITE, 0, 0, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, 0);

	if (hSerial == INVALID_HANDLE_VALUE)
	{
		printf("Unable to open port\n");
		return -1;
	}
	
	GetCommState(hSerial, &dcb);
	dcb.DCBlength = sizeof(DCB);
	dcb.BaudRate = CBR_115200; // CBR_2400, CBR_4800 CBR_9600 CBR_14400 CBR_19200 CBR_38400
	dcb.ByteSize = 8;
	dcb.StopBits = ONESTOPBIT;
	dcb.Parity = NOPARITY;

	if (SetCommState(hSerial, &dcb) == 0)
	{
		printf("Unable to set port params\n");
		return -1;
	}

	WriteFile(hSerial, msg, length, &nWrote, NULL);
	printf("Wrote %d bytes of message\n%s\n", nWrote, msg);
	CloseHandle(hSerial);
	return 0;
}